<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    
<script>
    //***********POLIMORFISMO*********************
    class Forma{
        dibujar(){
            console.log('Dibuja forma ...');
        }
        borrar(){
            console.log('borrando forma ...');
        }
    }
    class Circulo extends Forma{
        dibujar(){
            console.log('Calculando Diametro');
            console.log('Dibujando Circulo');
            this.hacerOtraCosa();
        }
        borrar(){
            console.log('Borrar circulo');
        }
        hacerOtraCosa(){
            console.log('haciendo otras cositas .... shhhhhh....');
        }
    }
    class Cuadrado extends Forma{
        dibujar(){
            console.log('Dibujando lado A...');
            console.log('Dibujando lado B...');
            console.log('Dibujando lado C...');
            console.log('Dibujando lado D...');
        }
        borrar(){
            console.log('Borrando cuadrado ...');
        }
    }
    class Pantalla{
        mostrarFormas(forma){
            forma.dibujar();
        }
        limpiarPantalla(forma){
            forma.borrar();
        }
    }
    
    let circulo1 = new Circulo();
    let circulo2 = new Circulo();
    let cuadrado1 = new Cuadrado();
    let myPantalla = new Pantalla();

    myPantalla.mostrarFormas(circulo1);
    myPantalla.limpiarPantalla(circulo1);

    myPantalla.mostrarFormas(circulo2);
    myPantalla.limpiarPantalla(circulo2);

    myPantalla.mostrarFormas(cuadrado1);
    myPantalla.limpiarPantalla(cuadrado1);

    //****************ENCAPSULAMIENTO*************
    // class Animal {
    //     constructor(n){
    //         this.nombre = n;
    //     }
    //     get nombre(){
    //         return 'Sr. '+this._nombre;
    //     }
    //     set nombre(n){
    //         this._nombre = n.trim();
    //     }
    //     hablar(){
    //         return "cuack";
    //     }
    //     quienSoy(){
    //         return "Hola, soy " + this.nombre;
    //     }
    // }
    // var pato = new Animal('Donald');








    //**************SOBRECARGA************
    // class Padre{
    //     tarea(){
    //         console.log('Tarea del padre..')
    //     }
    //     tarea(value){
    //         console.log('Tarea del padre con valor [sobrecarga]...' + value);
    //     }
    // }
    //     (new Padre()).tarea();

    //     class Hijo extends Padre{
    //         tarea(){
    //             super.tarea();
    //             console.log('... + Tarea del hijo')
    //         }
    //     }
    //     (new Hijo()).tarea();


    //*****************HERENCIA ************
    // class Forma{
    //     constructor(){
    //         console.log('Soy una forma geometrica');
    //     }
    //     gritar(){
    //         console.log('YEP!!');
    //     }    
    // }
    // class Cuadrado extends Forma{
    //     constructor(){
    //         super();
    //         console.log('Soy un cuadrado');
    //     }
    // }
    // class Circulo extends Forma{
    //     constructor(){
    //         super();
    //         console.log('Soy un circulo');
    //     }
    // }
    // class Triangulo extends Forma{
    //     constructor(){
    //         super();
    //         console.log('Soy un Triangulo');
    //     }
    // }
    // var c1 = new Cuadrado();
    // c1.gritar();
    // var t1 = new Triangulo();
    // t1.gritar();

    // var t3 = new Circulo();
    // t3.gritar();
</script>
</body>
</html>